// WHAT ARE YOU?!
#version 450
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define UTEXTURE_2D utexture2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define UTEXTURE_2D utexture2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////

layout(set = 1, binding = 0, std140) uniform _484_486
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
} _486;

layout(set = 0, binding = 0, std140) uniform _511_513
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
} _513;

layout(push_constant, std430) uniform _874_876
{
    int _m0;
    int _m1;
} _876;

layout(set = 1, binding = 1) uniform SAMPLER_2D _536;
layout(set = 1, binding = 2) uniform SAMPLER_2D _567;

layout(location = 0) out vec4 _596;

float _116;
float _156;

float _53(float _52)
{
    return 0.16666667163372039794921875 * ((_52 * ((_52 * ((-_52) + 3.0)) - 3.0)) + 1.0);
}

float _56(float _55)
{
    return 0.16666667163372039794921875 * (((_55 * _55) * ((3.0 * _55) - 6.0)) + 4.0);
}

float _65(float _64)
{
    float _275 = _64;
    float _278 = _64;
    return _53(_275) + _56(_278);
}

float _59(float _58)
{
    return 0.16666667163372039794921875 * ((_58 * ((_58 * (((-3.0) * _58) + 3.0)) + 3.0)) + 1.0);
}

float _62(float _61)
{
    return 0.16666667163372039794921875 * ((_61 * _61) * _61);
}

float _68(float _67)
{
    float _284 = _67;
    float _287 = _67;
    return _59(_284) + _62(_287);
}

float _71(float _70)
{
    float _294 = _70;
    float _297 = _70;
    float _300 = _70;
    return (-1.0) + (_56(_294) / (_53(_297) + _56(_300)));
}

float _74(float _73)
{
    float _308 = _73;
    float _311 = _73;
    float _314 = _73;
    return 1.0 + (_62(_308) / (_59(_311) + _62(_314)));
}

vec4 _46(SAMPLER_2D _43, vec4 _44, vec4 _45)
{
    vec2 _181 = _45.zw;
    vec2 _184 = clamp(_44.xy, vec2(0.0), _45.xy - (_181 / vec2(2.0)));
    return TEXTURE_LOD(_43, vec4(_184, _44.zw).xy, vec4(_184, _44.zw).w);
}

vec4 _83(SAMPLER_2D _79, inout vec2 _80, vec2 _81, vec4 _82)
{
    _80 = (_80 * _81) + vec2(0.5);
    vec2 _328 = floor(_80);
    vec2 _331 = fract(_80);
    float _335 = _331.x;
    float _334 = _65(_335);
    float _340 = _331.x;
    float _339 = _68(_340);
    float _345 = _331.x;
    float _344 = _71(_345);
    float _350 = _331.x;
    float _349 = _74(_350);
    float _355 = _331.y;
    float _354 = _71(_355);
    float _360 = _331.y;
    float _359 = _74(_360);
    vec2 _364 = (vec2(_328.x + _344, _328.y + _354) - vec2(0.5)) / _81;
    vec2 _378 = (vec2(_328.x + _349, _328.y + _354) - vec2(0.5)) / _81;
    vec2 _392 = (vec2(_328.x + _344, _328.y + _359) - vec2(0.5)) / _81;
    vec2 _406 = (vec2(_328.x + _349, _328.y + _359) - vec2(0.5)) / _81;
    vec4 _425 = vec4(_364, 0.0, 0.0);
    vec4 _426 = _82;
    vec4 _420 = _46(_79, _425, _426);
    vec4 _434 = vec4(_378, 0.0, 0.0);
    vec4 _435 = _82;
    vec4 _429 = _46(_79, _434, _435);
    vec4 _443 = vec4(_392, 0.0, 0.0);
    vec4 _444 = _82;
    vec4 _438 = _46(_79, _443, _444);
    vec4 _452 = vec4(_406, 0.0, 0.0);
    vec4 _453 = _82;
    vec4 _447 = _46(_79, _452, _453);
    float _456 = _331.y;
    float _468 = _331.y;
    return (((_420 * _334) + (_429 * _339)) * _65(_456)) + (((_438 * _334) + (_447 * _339)) * _68(_468));
}

vec3 _16(vec3 _15)
{
    return clamp(_15, vec3(0.0), vec3(1.0));
}

float _19(float _18)
{
    if (_18 <= 0.040449999272823333740234375)
    {
        return _18 / 12.9200000762939453125;
    }
    else
    {
        return pow((_18 / 1.05499994754791259765625) + 0.0521326996386051177978515625, 2.400000095367431640625);
    }
}

vec3 _22(vec3 _21)
{
    float _118 = _21.x;
    vec3 _117;
    _117.x = _19(_118);
    float _125 = _21.y;
    _117.y = _19(_125);
    float _131 = _21.z;
    _117.z = _19(_131);
    return _117;
}

float _25(float _24)
{
    if (_24 > 0.003130800090730190277099609375)
    {
        return (pow(_24, 0.4166666567325592041015625) * 1.05499994754791259765625) - 0.054999999701976776123046875;
    }
    else
    {
        return _24 * 12.9200000762939453125;
    }
}

vec3 _28(vec3 _27)
{
    float _158 = _27.x;
    vec3 _157;
    _157.x = _25(_158);
    float _163 = _27.y;
    _157.y = _25(_163);
    float _168 = _27.z;
    _157.z = _25(_168);
    return _157;
}

float _50(vec3 _49)
{
    return dot(_49, vec3(0.2125999927520751953125, 0.715200006961822509765625, 0.072200000286102294921875));
}

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

vec3 _35(mat3 _33, vec3 _34)
{
    return _33 * _34;
}

void main()
{
    vec2 _483 = _486._m0.xy + (_486._m0.zw * gl_FragCoord.xy);
    vec2 _502 = gl_FragCoord.xy * _486._m1.zw;
    vec4 _510 = vec4(_513._m0.xy, vec2(_486._m2.zw));
    vec2 _529 = _502 * _513._m0.xy;
    vec2 _537 = _529;
    vec2 _539 = _486._m2.xy;
    vec4 _543 = _510;
    vec4 _545 = _83(_536, _537, _539, _543);
    vec3 _535 = _545.xyz;
    vec4 _553 = vec4(_529, 0.0, 0.0);
    vec4 _554 = _510;
    vec3 _562 = mix(_535, _46(_536, _553, _554).xyz, _513._m1.zzz);
    vec3 _564 = _16(_562);
    vec3 _547 = _22(_564);
    vec4 _566 = TEXTURE_LOD(_567, vec4(_502, 0.0, 0.0).xy, vec4(_502, 0.0, 0.0).w);
    vec3 _580 = _566.xyz;
    vec3 _583 = _22(_580);
    _566 = vec4(_583.x, _583.y, _583.z, _566.w);
    vec3 _586 = (_547 * (1.0 - _566.w)) + _566.xyz;
    vec3 _597 = _586;
    vec3 _599 = _28(_597);
    _596 = vec4(_599.x, _599.y, _599.z, _596.w);
    if (_513._m2.x != 1.0)
    {
        vec3 _613 = pow(_596.xyz, _513._m2.xxx);
        _596 = vec4(_613.x, _613.y, _613.z, _596.w);
    }
    if (_513._m1.w > 0.0)
    {
        vec2 _621 = _483 + (vec2(ivec2(_486._m3.xy) & ivec2(1023)) / vec2(1023.0));
        float _637 = (fract(sin(_621.x + (_621.y * 521.0)) * 493013.0) * 2.0) - 1.0;
        vec3 _653 = _596.xyz;
        float _658 = 1.0 - _50(_653);
        vec3 _667 = _596.xyz + ((vec3(_637) * _10(_658)) * _513._m1.w);
        vec3 _668 = _16(_667);
        _596 = vec4(_668.x, _668.y, _668.z, _596.w);
    }
    mat3 _671 = mat3(vec3(0.2813999950885772705078125, -0.097099997103214263916015625, -0.093000002205371856689453125), vec3(0.6937999725341796875, 0.14579999446868896484375, -0.25290000438690185546875), vec3(0.063799999654293060302734375, -0.02500000037252902984619140625, 0.4665000140666961669921875));
    mat3 _685 = mat3(vec3(1.1677000522613525390625, 0.901400029659271240234375, 0.7214000225067138671875), vec3(-6.431499958038330078125, 2.5969998836517333984375, 0.1256999969482421875), vec3(-0.5044000148773193359375, 0.01590000092983245849609375, 2.051700115203857421875));
    if (_513._m1.x == 1.0)
    {
        vec3 _704 = vec3(0.20000000298023223876953125, 0.9900000095367431640625, -0.189999997615814208984375);
        vec3 _709 = vec3(0.1599999964237213134765625, 0.790000021457672119140625, 0.039999999105930328369140625);
        vec3 _714 = vec3(0.00999999977648258209228515625, -0.00999999977648258209228515625, 1.0);
        mat3 _719 = _671;
        vec3 _721 = _596.xyz;
        vec3 _718 = _35(_719, _721);
        _718.x -= (_718.y * 1.5);
        mat3 _733 = _685;
        vec3 _735 = _718;
        vec3 _737 = _35(_733, _735);
        _596 = vec4(_737.x, _737.y, _737.z, _596.w);
        vec3 _752 = vec3(dot(_596.xyz, _704), dot(_596.xyz, _709), dot(_596.xyz, _714));
        _596 = vec4(_752.x, _752.y, _752.z, _596.w);
    }
    else
    {
        if (_513._m1.x == 2.0)
        {
            vec3 _761 = vec3(0.430000007152557373046875, 0.7200000286102294921875, -0.1500000059604644775390625);
            vec3 _766 = vec3(0.3400000035762786865234375, 0.569999992847442626953125, 0.0900000035762786865234375);
            vec3 _771 = vec3(-0.0199999995529651641845703125, 0.02999999932944774627685546875, 1.0);
            mat3 _776 = _671;
            vec3 _778 = _596.xyz;
            vec3 _775 = _35(_776, _778);
            _775.x -= (_775.y * 1.5);
            mat3 _789 = _685;
            vec3 _791 = _775;
            vec3 _793 = _35(_789, _791);
            _596 = vec4(_793.x, _793.y, _793.z, _596.w);
            vec3 _808 = vec3(dot(_596.xyz, _761), dot(_596.xyz, _766), dot(_596.xyz, _771));
            _596 = vec4(_808.x, _808.y, _808.z, _596.w);
        }
        else
        {
            if (_513._m1.x == 3.0)
            {
                vec3 _817 = vec3(0.9700000286102294921875, 0.10999999940395355224609375, -0.07999999821186065673828125);
                vec3 _822 = vec3(0.0199999995529651641845703125, 0.819999992847442626953125, 0.1599999964237213134765625);
                vec3 _826 = vec3(-0.0599999986588954925537109375, 0.87999999523162841796875, 0.180000007152557373046875);
                mat3 _832 = _671;
                vec3 _834 = _596.xyz;
                vec3 _831 = _35(_832, _834);
                _831.x -= (((3.0 * _831.z) - _831.y) * 0.25);
                mat3 _850 = _685;
                vec3 _852 = _831;
                vec3 _854 = _35(_850, _852);
                _596 = vec4(_854.x, _854.y, _854.z, _596.w);
                vec3 _869 = vec3(dot(_596.xyz, _817), dot(_596.xyz, _822), dot(_596.xyz, _826));
                _596 = vec4(_869.x, _869.y, _869.z, _596.w);
            }
        }
    }
    _596.w = 1.0;
}



