#version 450
 #extension GL_EXT_multiview : enable
#define VIEW gl_ViewIndex

struct _186
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
};


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
 
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 30, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};


   

layout(set = 2, binding = 0, std140) uniform _45_47
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
} _47;

layout(set = 0, binding = 1, std430) restrict readonly buffer _92_94
{
    uint _m0[];
} _94;

layout(set = 0, binding = 2, std430) restrict readonly buffer _188_190
{
    _186 _m0[];
} _190;

layout(set = 1, binding = 0, std140) uniform _241_243
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
    vec4 _m21;
} _243;

layout(set = 0, binding = 0, std140) uniform _340_342
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
} _342;

layout(set = 0, binding = 15, std430) restrict readonly buffer _377_379
{
    uint _m0[];
} _379;

layout(set = 0, binding = 16, std140) uniform _382_384
{
    vec4 _m0[4096];
} _384;

layout(set = 0, binding = 17, std140) uniform _386_388
{
    vec4 _m0[4096];
} _388;

layout(set = 0, binding = 18, std140) uniform _390_392
{
    vec4 _m0[4096];
} _392;

layout(set = 0, binding = 20, std140) uniform _395_397
{
    vec4 _m0[4096];
} _397;

layout(set = 0, binding = 21, std140) uniform _399_401
{
    vec4 _m0[4096];
} _401;

layout(set = 0, binding = 22, std140) uniform _404_406
{
    vec4 _m0[3072];
} _406;

layout(set = 0, binding = 24, std140) uniform _410_412
{
    vec4 _m0[4095];
} _412;

layout(set = 0, binding = 26, std140) uniform _418_420
{
    vec4 _m0[4096];
} _420;

layout(push_constant, std430) uniform _60_62
{
    int _m0;
    int _m1;
} _62;

layout(set = 0, binding = 3) uniform sampler _360;
layout(set = 0, binding = 4) uniform sampler _361;
layout(set = 0, binding = 5) uniform sampler _362;
layout(set = 0, binding = 6) uniform sampler _363;
layout(set = 0, binding = 7) uniform sampler _364;
layout(set = 0, binding = 8) uniform sampler _365;
layout(set = 0, binding = 9) uniform sampler _366;
layout(set = 0, binding = 10) uniform sampler2D _370;
layout(set = 0, binding = 11) uniform sampler2D _371;
layout(set = 0, binding = 12) uniform sampler2D _372;
layout(set = 0, binding = 13, r32f) uniform readonly writeonly image2D _375;
layout(set = 0, binding = 19) uniform sampler2D _393;
layout(set = 0, binding = 23) uniform sampler2D _407;
layout(set = 0, binding = 25) uniform sampler2DShadow _416;
layout(set = 0, binding = 27) uniform sampler2D _421;

layout(location = 14) flat out uvec3 _134;
layout(location = 2) out vec4 _141;
layout(location = 1) in vec2 _144;
layout(location = 12) in vec2 _147;
layout(location = 0) in vec4 _152;
layout(location = 2) in vec4 _161;
layout(location = 9) in vec4 _168;
layout(location = 3) out vec4 _240;
layout(location = 4) out vec4 _270;
layout(location = 5) out vec4 _310;

float _19(vec4 _17, vec4 _18)
{
    return dot(_17, _18);
}

float _14(vec3 _12, vec4 _13)
{
    return dot(_12, _13.xyz);
}

void main()
{
    vec4 _32 = vec4(0.0);
    vec3 _35 = vec3(0.0);
    uvec2 _40 = uvec2(0u);
    uint _44 = 0u;
    if (_47._m1.x > 0.0)
    {
        int _58 = int(_47._m2[_62._m0]);
        int _70 = gl_VertexIndex & 16777215;
        int _76 = _70 + _58;
        uint _80 = uint(_76 / 2);
        uint _84 = uint(16 * (_76 & 1));
        uint _90 = _94._m0[_80] >> _84;
        _40.x = _90 & 7u;
        _40.y = (_90 >> uint(3)) & 7u;
        _35.x = float((_90 >> uint(6)) & 63u) / 63.0;
        _35.y = 0.0;
        _35.z = float((_90 >> uint(12)) & 15u) / 15.0;
    }
    _134 = uvec3(_40.x, _40.y, 0u);
    _141 = _144.xyxy;
    _141 = vec4(_141.x, _141.y, _147.x, _147.y);
    _32 = vec4(_152.xyz, 1.0);
    vec4 _160 = (_161 * 2.0) - vec4(1.0);
    vec4 _167 = (_168 * 2.0) - vec4(1.0);
    _167.w = (floor((_168.w * 255.100006103515625) / 128.0) * 2.0) - 1.0;
    vec4 _185 = _190._m0[_62._m1]._m0;
    vec4 _196 = _190._m0[_62._m1]._m1;
    vec4 _201 = _190._m0[_62._m1]._m2;
    vec4 _206 = _190._m0[_62._m1]._m3;
    vec4 _215 = _32;
    vec4 _217 = _185;
    gl_Position.x = _19(_215, _217);
    vec4 _222 = _32;
    vec4 _224 = _196;
    gl_Position.y = _19(_222, _224);
    vec4 _228 = _32;
    vec4 _230 = _201;
    gl_Position.z = _19(_228, _230);
    vec4 _234 = _32;
    vec4 _236 = _206;
    gl_Position.w = _19(_234, _236);
    vec3 _245 = _160.xyz;
    vec4 _248 = _243._m5;
    _240.x = _14(_245, _248);
    vec3 _253 = _160.xyz;
    vec4 _256 = _243._m6;
    _240.y = _14(_253, _256);
    vec3 _262 = _160.xyz;
    vec4 _265 = _243._m7;
    _240.z = _14(_262, _265);
    vec3 _271 = _167.xyz;
    vec4 _274 = _243._m5;
    _270.x = _14(_271, _274);
    vec3 _279 = _167.xyz;
    vec4 _282 = _243._m6;
    _270.y = _14(_279, _282);
    vec3 _287 = _167.xyz;
    vec4 _290 = _243._m7;
    _270.z = _14(_287, _290);
    _270.w = sign(_167.w * (-_243._m12.x));
    _270.w *= (1.0 + _35.x);
    _310.x = _35.z;
    vec4 _315 = _32;
    vec4 _317 = _243._m5;
    vec4 _314;
    _314.x = _19(_315, _317);
    vec4 _322 = _32;
    vec4 _324 = _243._m6;
    _314.y = _19(_322, _324);
    vec4 _329 = _32;
    vec4 _331 = _243._m7;
    _314.z = _19(_329, _331);
    _314.w = 1.0;
    vec3 _337 = _314.xyz - _342._m0.xyz;
    _310 = vec4(_310.x, _310.y, _337.xy.x, _337.xy.y);
    _240.w = _337.z;
    gl_Position.y = -gl_Position.y;

// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].stereo.y); 
/*
//_141.x += vk3d_params[VIEW].stereo.x * (_141.w - vk3d_params[VIEW].stereo.y);
//_240.x /= vk3d_params[VIEW].stereo.y;
if(_240.w < 0)
{
//_240.x -= vk3d_params[VIEW].stereo.x * (1.0-_240.z * vk3d_params[VIEW].stereo.y);
//_240.x -= vk3d_params[VIEW].stereo.x *0.5;
//_240.z = 0.01;
}
else
{
_240.x += vk3d_params[VIEW].stereo.x * (1.0 - _240.z * vk3d_params[VIEW].stereo.y);
}
*/


//_270.x += vk3d_params[VIEW].stereo.x * (_270.w - vk3d_params[VIEW].stereo.y);
//_310.x += vk3d_params[VIEW].stereo.x * (_310.w - vk3d_params[VIEW].stereo.y); 
}



