// GEO
#version 450
 #extension GL_EXT_multiview : enable
#define VIEW gl_ViewIndex

struct _358
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
};


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 10, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};

layout(set = 2, binding = 0, std140) uniform _93_95
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
} _95;

layout(set = 1, binding = 0, std140) uniform _115_117
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
    vec4 _m21;
    vec4 _m22;
    vec4 _m23;
    vec4 _m24;
    vec4 _m25;
    vec4 _m26;
    vec4 _m27;
    vec4 _m28;
    vec4 _m29;
    vec4 _m30;
} _117;

layout(set = 0, binding = 1, std430) restrict readonly buffer _142_144
{
    vec4 _m0[];
} _144;

layout(set = 0, binding = 2, std430) restrict readonly buffer _360_362
{
    _358 _m0[];
} _362;

layout(set = 0, binding = 0, std140) uniform _512_514
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
} _514;

layout(push_constant, std430) uniform _363_365
{
    int _m0;
    int _m1;
} _365;

layout(set = 0, binding = 3) uniform sampler2D _1542;
layout(set = 1, binding = 1) uniform sampler2D _1543;

layout(location = 0) in vec4 _56;
layout(location = 2) in vec4 _65;
layout(location = 9) in vec4 _72;
layout(location = 3) in vec4 _125;
layout(location = 1) in vec2 _521;
layout(location = 12) in vec2 _523;
layout(location = 2) out vec4 _531;
layout(location = 8) out vec4 _539;
layout(location = 9) out vec4 _929;
layout(location = 3) out vec4 _1235;
layout(location = 4) out vec4 _1533;

float _23(vec4 _21, vec4 _22)
{
    return dot(_21, _22);
}

float _19(vec4 _17, vec4 _18)
{
    return dot(_17.xyz, _18.xyz);
}

float _12(vec3 _10, vec3 _11)
{
    return dot(_10, _11);
}

mat4 _30(mat4 _28, mat4 _29)
{
    return _28 * _29;
}

void main()
{
    vec4 _54 = vec4(_56.xyz, 1.0);
    vec4 _64 = (_65 * 2.0) - vec4(1.0);
    vec4 _71 = (_72 * 2.0) - vec4(1.0);
    _71.w = (floor((_72.w * 255.100006103515625) / 128.0) * 2.0) - 1.0;
    float _91 = 0.0;
    if (_95._m0.z != 0.0)
    {
        vec4 _106 = _54;
        vec4 _108 = vec4(0.0);
        vec4 _110 = vec4(0.0);
        vec4 _111 = vec4(0.0);
        uvec4 _114 = uvec4(uint(_117._m0.x + _95._m0.x)) + uvec4(_125 * 255.0);
        if (_95._m0.z == 1.0)
        {
            uint _138 = _114.x;
            _108 = _144._m0[(_138 * 3u) + 0u];
            _110 = _144._m0[(_138 * 3u) + 1u];
            _111 = _144._m0[(_138 * 3u) + 2u];
        }
        else
        {
            float _163 = _72.w * 255.100006103515625;
            vec4 _167;
            _167.y = _163 - (floor(_163 / 128.0) * 128.0);
            float _175 = _65.w * 255.100006103515625;
            _167.z = floor(_175 / 16.0);
            _167.w = _175 - (_167.z * 16.0);
            _167.y *= 0.00393700785934925079345703125;
            _167.z *= 0.02222222276031970977783203125;
            _167.w *= 0.01666666753590106964111328125;
            _167.x = 1.0 - ((_167.y + _167.z) + _167.w);
            for (uint _215 = 0u; _215 < 4u; _215++)
            {
                _108 += (_144._m0[(_114[_215] * 3u) + 0u] * _167[_215]);
            }
            for (uint _240 = 0u; _240 < 4u; _240++)
            {
                _110 += (_144._m0[(_114[_240] * 3u) + 1u] * _167[_240]);
            }
            for (uint _263 = 0u; _263 < 4u; _263++)
            {
                _111 += (_144._m0[(_114[_263] * 3u) + 2u] * _167[_263]);
            }
        }
        vec4 _286 = _106;
        vec4 _288 = _108;
        _54.x = _23(_286, _288);
        vec4 _292 = _106;
        vec4 _294 = _110;
        _54.y = _23(_292, _294);
        vec4 _298 = _106;
        vec4 _300 = _111;
        _54.z = _23(_298, _300);
        _54.w = 1.0;
        vec4 _305 = _64;
        vec4 _307 = _305;
        vec4 _309 = _108;
        _64.x = _19(_307, _309);
        vec4 _313 = _305;
        vec4 _315 = _110;
        _64.y = _19(_313, _315);
        vec4 _319 = _305;
        vec4 _321 = _111;
        _64.z = _19(_319, _321);
        vec4 _325 = _71;
        vec4 _327 = _325;
        vec4 _329 = _108;
        _71.x = _19(_327, _329);
        vec4 _333 = _325;
        vec4 _335 = _110;
        _71.y = _19(_333, _335);
        vec4 _339 = _325;
        vec4 _341 = _111;
        _71.z = _19(_339, _341);
    }
    vec3 _353 = cross(_64.xyz, _71.xyz) * _71.w;
    vec4 _345;
    _345 = vec4(_353.x, _353.y, _353.z, _345.w);
    _345.w = 0.0;
    vec4 _357 = _362._m0[_365._m1]._m0;
    vec4 _371 = _362._m0[_365._m1]._m1;
    vec4 _376 = _362._m0[_365._m1]._m2;
    vec4 _382 = _362._m0[_365._m1]._m3;
    vec4 _392 = _54;
    vec4 _394 = _357;
    gl_Position.x = _23(_392, _394);
    vec4 _399 = _54;
    vec4 _401 = _371;
    gl_Position.y = _23(_399, _401);
    vec4 _405 = _54;
    vec4 _407 = _376;
    gl_Position.z = _23(_405, _407);
    vec4 _411 = _54;
    vec4 _413 = _382;
    gl_Position.w = _23(_411, _413);
    vec4 _418 = _71;
    vec4 _420 = _117._m1;
    vec4 _417;
    _417.x = _19(_418, _420);
    vec4 _425 = _345;
    vec4 _427 = _117._m1;
    _417.y = _19(_425, _427);
    vec4 _432 = _64;
    vec4 _434 = _117._m1;
    _417.z = _19(_432, _434);
    _417.w = _91;
    vec4 _442 = _71;
    vec4 _444 = _117._m2;
    vec4 _441;
    _441.x = _19(_442, _444);
    vec4 _449 = _345;
    vec4 _451 = _117._m2;
    _441.y = _19(_449, _451);
    vec4 _456 = _64;
    vec4 _458 = _117._m2;
    _441.z = _19(_456, _458);
    _441.w = 0.0;
    vec4 _465 = _71;
    vec4 _467 = _117._m3;
    vec4 _464;
    _464.x = _19(_465, _467);
    vec4 _472 = _345;
    vec4 _474 = _117._m3;
    _464.y = _19(_472, _474);
    vec4 _479 = _64;
    vec4 _481 = _117._m3;
    _464.z = _19(_479, _481);
    _464.w = 0.0;
    vec4 _488 = _54;
    vec4 _490 = _117._m1;
    vec4 _487;
    _487.x = _23(_488, _490);
    vec4 _495 = _54;
    vec4 _497 = _117._m2;
    _487.y = _23(_495, _497);
    vec4 _502 = _54;
    vec4 _504 = _117._m3;
    _487.z = _23(_502, _504);
    _487.w = 1.0;
    vec4 _510 = _487 - _514._m0;
    vec4 _518 = vec4(_521, _523);
    _531 = _518 + _95._m1;
    vec3 _536 = _56.xyz;
    _539 = vec4(0.0);
    vec3 _540 = (_117._m4.xyz - _536) * _117._m4.w;
    vec3 _550 = (_117._m5.xyz - _536) * _117._m5.w;
    vec3 _560 = (_117._m6.xyz - _536) * _117._m6.w;
    vec3 _570 = (_117._m7.xyz - _536) * _117._m7.w;
    vec3 _580 = (_117._m8.xyz - _536) * _117._m8.w;
    vec3 _590 = (_117._m9.xyz - _536) * _117._m9.w;
    vec3 _600 = (_117._m10.xyz - _536) * _117._m10.w;
    vec3 _610 = (_117._m11.xyz - _536) * _117._m11.w;
    vec3 _620 = (_117._m12.xyz - _536) * _117._m12.w;
    vec3 _630 = (_117._m13.xyz - _536) * _117._m13.w;
    vec3 _640 = (_117._m14.xyz - _536) * _117._m14.w;
    vec3 _650 = (_117._m15.xyz - _536) * _117._m15.w;
    vec3 _660 = (_117._m16.xyz - _536) * _117._m16.w;
    vec3 _670 = (_117._m17.xyz - _536) * _117._m17.w;
    vec3 _680 = (_117._m18.xyz - _536) * _117._m18.w;
    vec3 _690 = (_117._m19.xyz - _536) * _117._m19.w;
    vec3 _700 = (_117._m20.xyz - _536) * _117._m20.w;
    vec3 _710 = (_117._m21.xyz - _536) * _117._m21.w;
    vec3 _720 = (_117._m22.xyz - _536) * _117._m22.w;
    vec3 _730 = (_117._m23.xyz - _536) * _117._m23.w;
    vec3 _741 = _540;
    vec3 _743 = _540;
    float _740 = _12(_741, _743);
    vec3 _747 = _550;
    vec3 _749 = _550;
    float _746 = _12(_747, _749);
    vec3 _753 = _560;
    vec3 _755 = _560;
    float _752 = _12(_753, _755);
    vec3 _759 = _570;
    vec3 _761 = _570;
    float _758 = _12(_759, _761);
    vec3 _765 = _580;
    vec3 _767 = _580;
    float _764 = _12(_765, _767);
    vec3 _771 = _590;
    vec3 _773 = _590;
    float _770 = _12(_771, _773);
    vec3 _777 = _600;
    vec3 _779 = _600;
    float _776 = _12(_777, _779);
    vec3 _783 = _610;
    vec3 _785 = _610;
    float _782 = _12(_783, _785);
    vec3 _789 = _620;
    vec3 _791 = _620;
    float _788 = _12(_789, _791);
    vec3 _795 = _630;
    vec3 _797 = _630;
    float _794 = _12(_795, _797);
    vec3 _801 = _640;
    vec3 _803 = _640;
    float _800 = _12(_801, _803);
    vec3 _807 = _650;
    vec3 _809 = _650;
    float _806 = _12(_807, _809);
    vec3 _813 = _660;
    vec3 _815 = _660;
    float _812 = _12(_813, _815);
    vec3 _819 = _670;
    vec3 _821 = _670;
    float _818 = _12(_819, _821);
    vec3 _825 = _680;
    vec3 _827 = _680;
    float _824 = _12(_825, _827);
    vec3 _831 = _690;
    vec3 _833 = _690;
    float _830 = _12(_831, _833);
    vec3 _837 = _700;
    vec3 _839 = _700;
    float _836 = _12(_837, _839);
    vec3 _843 = _710;
    vec3 _845 = _710;
    float _842 = _12(_843, _845);
    vec3 _849 = _720;
    vec3 _851 = _720;
    float _848 = _12(_849, _851);
    vec3 _855 = _730;
    vec3 _857 = _730;
    float _854 = _12(_855, _857);
    float _860 = min(_740, _746);
    _860 = min(_860, _752);
    _860 = min(_860, _758);
    _860 = min(_860, _764);
    _860 = min(_860, _770);
    _860 = min(_860, _776);
    _860 = min(_860, _782);
    _860 = min(_860, _788);
    _860 = min(_860, _794);
    _860 = min(_860, _800);
    _860 = min(_860, _806);
    float _894 = min(_812, _818);
    _894 = min(_894, _824);
    _894 = min(_894, _830);
    _894 = min(_894, _836);
    _894 = min(_894, _842);
    _894 = min(_894, _848);
    _894 = min(_894, _854);
    float _916 = sqrt(min(_860, _894)) - 1.0;
    float _922 = sqrt(_860) - 1.0;
    _539 = vec4(_916, 0.0, 0.0, _922);
    vec2 _936 = _531.xy * _117._m24.xy;
    _929 = vec4(_936.x, _936.y, _929.z, _929.w);
    _929 = vec4(_929.x, _929.y, vec2(0.0).x, vec2(0.0).y);
    mat4 _942 = mat4(vec4(_117._m1), vec4(_117._m2), vec4(_117._m3), vec4(_117._m25));
    mat4 _973 = mat4(vec4(_514._m1), vec4(_514._m2), vec4(_514._m3), vec4(_514._m4));
    mat4 _1004 = _942;
    mat4 _1006 = _973;
    mat4 _1003 = _30(_1004, _1006);
    vec4 _1009 = _1003[0];
    vec4 _1012 = _1003[1];
    vec4 _1015 = _1003[2];
    vec4 _1018 = _1003[3];
    vec4 _1021 = vec4(_56.xyz, 1.0);
    if (_95._m0.z != 0.0)
    {
        vec4 _1033 = _1021;
        vec4 _1035 = vec4(0.0);
        vec4 _1036 = vec4(0.0);
        vec4 _1037 = vec4(0.0);
        uvec4 _1038 = uvec4(uint(_117._m0.x + _95._m0.x)) + uvec4(_125 * 255.0);
        if (_95._m0.z == 1.0)
        {
            uint _1055 = _1038.x;
            _1035 = _144._m0[(_1055 * 3u) + 0u];
            _1036 = _144._m0[(_1055 * 3u) + 1u];
            _1037 = _144._m0[(_1055 * 3u) + 2u];
        }
        else
        {
            float _1074 = _72.w * 255.100006103515625;
            vec4 _1078;
            _1078.y = _1074 - (floor(_1074 / 128.0) * 128.0);
            float _1086 = _65.w * 255.100006103515625;
            _1078.z = floor(_1086 / 16.0);
            _1078.w = _1086 - (_1078.z * 16.0);
            _1078.y *= 0.00393700785934925079345703125;
            _1078.z *= 0.02222222276031970977783203125;
            _1078.w *= 0.01666666753590106964111328125;
            _1078.x = 1.0 - ((_1078.y + _1078.z) + _1078.w);
            for (uint _1122 = 0u; _1122 < 4u; _1122++)
            {
                _1035 += (_144._m0[(_1038[_1122] * 3u) + 0u] * _1078[_1122]);
            }
            for (uint _1145 = 0u; _1145 < 4u; _1145++)
            {
                _1036 += (_144._m0[(_1038[_1145] * 3u) + 1u] * _1078[_1145]);
            }
            for (uint _1168 = 0u; _1168 < 4u; _1168++)
            {
                _1037 += (_144._m0[(_1038[_1168] * 3u) + 2u] * _1078[_1168]);
            }
        }
        vec4 _1191 = _1033;
        vec4 _1193 = _1035;
        _1021.x = _23(_1191, _1193);
        vec4 _1197 = _1033;
        vec4 _1199 = _1036;
        _1021.y = _23(_1197, _1199);
        vec4 _1203 = _1033;
        vec4 _1205 = _1037;
        _1021.z = _23(_1203, _1205);
        _1021.w = 1.0;
    }
    vec4 _1211 = _1021;
    vec4 _1213 = _1009;
    vec4 _1210;
    _1210.x = _23(_1211, _1213);
    vec4 _1217 = _1021;
    vec4 _1219 = _1012;
    _1210.y = _23(_1217, _1219);
    vec4 _1223 = _1021;
    vec4 _1225 = _1015;
    _1210.z = _23(_1223, _1225);
    vec4 _1229 = _1021;
    vec4 _1231 = _1018;
    _1210.w = _23(_1229, _1231);
    _1235 = _1210;
    mat4 _1237 = mat4(vec4(_117._m26), vec4(_117._m27), vec4(_117._m28), vec4(_117._m29));
    mat4 _1271 = mat4(vec4(_514._m5), vec4(_514._m6), vec4(_514._m7), vec4(_514._m8));
    mat4 _1302 = _1237;
    mat4 _1304 = _1271;
    mat4 _1301 = _30(_1302, _1304);
    vec4 _1307 = _1301[0];
    vec4 _1310 = _1301[1];
    vec4 _1313 = _1301[2];
    vec4 _1316 = _1301[3];
    vec4 _1319 = vec4(_56.xyz, 1.0);
    if (_95._m0.z != 0.0)
    {
        vec4 _1331 = _1319;
        vec4 _1333 = vec4(0.0);
        vec4 _1334 = vec4(0.0);
        vec4 _1335 = vec4(0.0);
        uvec4 _1336 = uvec4(uint(_117._m0.y + _95._m0.y)) + uvec4(_125 * 255.0);
        if (_95._m0.z == 1.0)
        {
            uint _1353 = _1336.x;
            _1333 = _144._m0[(_1353 * 3u) + 0u];
            _1334 = _144._m0[(_1353 * 3u) + 1u];
            _1335 = _144._m0[(_1353 * 3u) + 2u];
        }
        else
        {
            float _1372 = _72.w * 255.100006103515625;
            vec4 _1376;
            _1376.y = _1372 - (floor(_1372 / 128.0) * 128.0);
            float _1384 = _65.w * 255.100006103515625;
            _1376.z = floor(_1384 / 16.0);
            _1376.w = _1384 - (_1376.z * 16.0);
            _1376.y *= 0.00393700785934925079345703125;
            _1376.z *= 0.02222222276031970977783203125;
            _1376.w *= 0.01666666753590106964111328125;
            _1376.x = 1.0 - ((_1376.y + _1376.z) + _1376.w);
            for (uint _1420 = 0u; _1420 < 4u; _1420++)
            {
                _1333 += (_144._m0[(_1336[_1420] * 3u) + 0u] * _1376[_1420]);
            }
            for (uint _1443 = 0u; _1443 < 4u; _1443++)
            {
                _1334 += (_144._m0[(_1336[_1443] * 3u) + 1u] * _1376[_1443]);
            }
            for (uint _1466 = 0u; _1466 < 4u; _1466++)
            {
                _1335 += (_144._m0[(_1336[_1466] * 3u) + 2u] * _1376[_1466]);
            }
        }
        vec4 _1489 = _1331;
        vec4 _1491 = _1333;
        _1319.x = _23(_1489, _1491);
        vec4 _1495 = _1331;
        vec4 _1497 = _1334;
        _1319.y = _23(_1495, _1497);
        vec4 _1501 = _1331;
        vec4 _1503 = _1335;
        _1319.z = _23(_1501, _1503);
        _1319.w = 1.0;
    }
    vec4 _1509 = _1319;
    vec4 _1511 = _1307;
    vec4 _1508;
    _1508.x = _23(_1509, _1511);
    vec4 _1515 = _1319;
    vec4 _1517 = _1310;
    _1508.y = _23(_1515, _1517);
    vec4 _1521 = _1319;
    vec4 _1523 = _1313;
    _1508.z = _23(_1521, _1523);
    vec4 _1527 = _1319;
    vec4 _1529 = _1316;
    _1508.w = _23(_1527, _1529);
    _1533 = _1508;
    gl_Position.y = -gl_Position.y;

// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
    // Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
    if(vk3d_params[VIEW].custom_params.z != 0)
    {
        if (gl_Position.w > vk3d_params[VIEW].custom_params.z)
            gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].stereo.y); 
        else
            gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].custom_params.w) *0.75;
    }
    else
    {
        gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].stereo.y); 
    }
}


