
// Vk3DVision (http://3dsurroundgaming.com/) - Original Shader
#version 450
 #extension GL_EXT_multiview : enable
#define VIEW gl_ViewIndex

layout(set = 2, binding = 0, std140) uniform _90_92
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
} _92;

layout(set = 1, binding = 0, std140) uniform _112_114
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
} _114;

layout(set = 0, binding = 1, std430) restrict readonly buffer _139_141
{
    vec4 _m0[];
} _141;

layout(set = 0, binding = 0, std140) uniform _415_417
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
} _417;

layout(push_constant, std430) uniform _533_535
{
    int _m0;
    int _m1;
} _535;

layout(set = 0, binding = 2) uniform sampler _538;
layout(set = 2, binding = 1) uniform sampler2D _542;

layout(location = 0) in vec4 _56;
layout(location = 2) in vec4 _64;
layout(location = 9) in vec4 _71;
layout(location = 3) in vec4 _122;
layout(location = 1) in vec2 _497;
layout(location = 12) in vec2 _499;
layout(location = 2) out vec4 _507;
layout(location = 3) out vec4 _520;
layout(location = 14) flat out uvec3 _527;

float _21(vec4 _19, vec4 _20)
{
    return dot(_19, _20);
}

float _17(vec4 _15, vec4 _16)
{
    return dot(_15.xyz, _16.xyz);
}

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

mat4 _28(mat4 _26, mat4 _27)
{
    return _26 * _27;
}

void main()
{
    vec4 _54 = vec4(_56.xyz, 1.0);
    vec4 _63 = (_64 * 2.0) - vec4(1.0);
    vec4 _70 = (_71 * 2.0) - vec4(1.0);
    _70.w = (floor((_71.w * 255.100006103515625) / 128.0) * 2.0) - 1.0;
    float _89 = 0.0;
    if (_92._m0.z != 0.0)
    {
        vec4 _103 = _54;
        vec4 _105 = vec4(0.0);
        vec4 _107 = vec4(0.0);
        vec4 _108 = vec4(0.0);
        uvec4 _111 = uvec4(uint(_114._m0.x + _92._m0.x)) + uvec4(_122 * 255.0);
        if (_92._m0.z == 1.0)
        {
            uint _135 = _111.x;
            _105 = _141._m0[(_135 * 3u) + 0u];
            _107 = _141._m0[(_135 * 3u) + 1u];
            _108 = _141._m0[(_135 * 3u) + 2u];
        }
        else
        {
            float _160 = _71.w * 255.100006103515625;
            vec4 _164;
            _164.y = _160 - (floor(_160 / 128.0) * 128.0);
            float _172 = _64.w * 255.100006103515625;
            _164.z = floor(_172 / 16.0);
            _164.w = _172 - (_164.z * 16.0);
            _164.y *= 0.00393700785934925079345703125;
            _164.z *= 0.02222222276031970977783203125;
            _164.w *= 0.01666666753590106964111328125;
            _164.x = 1.0 - ((_164.y + _164.z) + _164.w);
            for (uint _212 = 0u; _212 < 4u; _212++)
            {
                _105 += (_141._m0[(_111[_212] * 3u) + 0u] * _164[_212]);
            }
            for (uint _237 = 0u; _237 < 4u; _237++)
            {
                _107 += (_141._m0[(_111[_237] * 3u) + 1u] * _164[_237]);
            }
            for (uint _260 = 0u; _260 < 4u; _260++)
            {
                _108 += (_141._m0[(_111[_260] * 3u) + 2u] * _164[_260]);
            }
        }
        vec4 _283 = _103;
        vec4 _285 = _105;
        _54.x = _21(_283, _285);
        vec4 _289 = _103;
        vec4 _291 = _107;
        _54.y = _21(_289, _291);
        vec4 _295 = _103;
        vec4 _297 = _108;
        _54.z = _21(_295, _297);
        _54.w = 1.0;
        vec4 _302 = _63;
        vec4 _304 = _302;
        vec4 _306 = _105;
        _63.x = _17(_304, _306);
        vec4 _310 = _302;
        vec4 _312 = _107;
        _63.y = _17(_310, _312);
        vec4 _316 = _302;
        vec4 _318 = _108;
        _63.z = _17(_316, _318);
        vec4 _322 = _70;
        vec4 _324 = _322;
        vec4 _326 = _105;
        _70.x = _17(_324, _326);
        vec4 _330 = _322;
        vec4 _332 = _107;
        _70.y = _17(_330, _332);
        vec4 _336 = _322;
        vec4 _338 = _108;
        _70.z = _17(_336, _338);
    }
    float _342 = length(_114._m1.xyz - _54.xyz);
    float _360 = abs(_342 - _114._m2.z) / _114._m2.x;
    float _350 = 1.0 - _10(_360);
    float _363 = ((_350 * _350) * _114._m2.y) * 0.00999999977648258209228515625;
    _54 += (_63 * vec4(_363, _363, _363, 0.0));
    mat4 _380 = mat4(vec4(_114._m3), vec4(_114._m4), vec4(_114._m5), vec4(_114._m6));
    mat4 _414 = mat4(vec4(_417._m0), vec4(_417._m1), vec4(_417._m2), vec4(_417._m3));
    mat4 _448 = _380;
    mat4 _450 = _414;
    mat4 _447 = _28(_448, _450);
    vec4 _453 = _447[0];
    vec4 _456 = _447[1];
    vec4 _459 = _447[2];
    vec4 _462 = _447[3];
    vec4 _469 = _54;
    vec4 _471 = _453;
    gl_Position.x = _21(_469, _471);
    vec4 _476 = _54;
    vec4 _478 = _456;
    gl_Position.y = _21(_476, _478);
    vec4 _482 = _54;
    vec4 _484 = _459;
    gl_Position.z = _21(_482, _484);
    vec4 _488 = _54;
    vec4 _490 = _462;
    gl_Position.w = _21(_488, _490);
    vec4 _494 = vec4(_497, _499);
    _507 = _494 + _92._m1;
    vec4 _512 = vec4(_497, _499);
    _520 = _512 + _92._m1;
    _527 = uvec3(0u);
    gl_Position.y = -gl_Position.y;
}

