// BODY 4
#version 450
 #extension GL_EXT_multiview : enable
#define VIEW gl_ViewIndex

struct _673
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
};


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
 
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 30, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};


   

layout(set = 2, binding = 0, std140) uniform _56_58
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
} _58;

layout(set = 0, binding = 1, std430) restrict readonly buffer _103_105
{
    uint _m0[];
} _105;

layout(set = 0, binding = 0, std140) uniform _196_198
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
} _198;

layout(set = 1, binding = 0, std140) uniform _246_248
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
} _248;

layout(set = 0, binding = 2, std430) restrict readonly buffer _461_463
{
    vec4 _m0[];
} _463;

layout(set = 0, binding = 3, std430) restrict readonly buffer _675_677
{
    _673 _m0[];
} _677;

layout(set = 0, binding = 14, std430) restrict readonly buffer _1214_1216
{
    uint _m0[];
} _1216;

layout(set = 0, binding = 15, std140) uniform _1219_1221
{
    vec4 _m0[4096];
} _1221;

layout(set = 0, binding = 16, std140) uniform _1223_1225
{
    vec4 _m0[4096];
} _1225;

layout(set = 0, binding = 17, std140) uniform _1227_1229
{
    vec4 _m0[4096];
} _1229;

layout(set = 0, binding = 19, std140) uniform _1235_1237
{
    vec4 _m0[4096];
} _1237;

layout(set = 0, binding = 20, std140) uniform _1239_1241
{
    vec4 _m0[4096];
} _1241;

layout(set = 0, binding = 21, std140) uniform _1244_1246
{
    vec4 _m0[3072];
} _1246;

layout(set = 0, binding = 23, std140) uniform _1249_1251
{
    vec4 _m0[4095];
} _1251;

layout(set = 0, binding = 25, std140) uniform _1257_1259
{
    vec4 _m0[4096];
} _1259;

layout(push_constant, std430) uniform _71_73
{
    int _m0;
    int _m1;
} _73;

layout(set = 0, binding = 4) uniform sampler3D _1007;
layout(set = 0, binding = 5) uniform sampler3D _1086;
layout(set = 0, binding = 6) uniform sampler _1206;
layout(set = 0, binding = 7) uniform sampler _1207;
layout(set = 0, binding = 8) uniform sampler _1208;
layout(set = 0, binding = 9) uniform sampler _1209;
layout(set = 0, binding = 10) uniform sampler _1210;
layout(set = 0, binding = 11) uniform sampler _1211;
layout(set = 0, binding = 12) uniform sampler _1212;
layout(set = 0, binding = 18) uniform sampler2D _1233;
layout(set = 0, binding = 22) uniform sampler2D _1247;
layout(set = 0, binding = 24) uniform sampler2DShadow _1255;
layout(set = 0, binding = 26) uniform sampler2D _1260;
layout(set = 0, binding = 27) uniform sampler2D _1261;

layout(location = 15) out vec4 _144;
layout(location = 14) flat out uvec3 _152;
layout(location = 0) in vec4 _159;
layout(location = 2) in vec4 _167;
layout(location = 9) in vec4 _174;
layout(location = 3) in vec4 _231;
layout(location = 3) out vec4 _726;
layout(location = 4) out vec4 _750;
layout(location = 5) out vec4 _773;
layout(location = 6) out vec4 _819;
layout(location = 1) in vec2 _826;
layout(location = 12) in vec2 _828;
layout(location = 2) out vec4 _835;
layout(location = 10) out vec4 _847;
layout(location = 11) out vec4 _848;
layout(location = 12) out vec4 _849;

float _22(vec4 _20, vec4 _21)
{
    return dot(_20, _21);
}

float _18(vec4 _16, vec4 _17)
{
    return dot(_16.xyz, _17.xyz);
}

vec3 _11(vec3 _10)
{
    return clamp(_10, vec3(0.0), vec3(1.0));
}

void main()
{
    vec4 _44 = vec4(0.0);
    vec3 _46 = vec3(0.0);
    uvec2 _51 = uvec2(0u);
    uint _55 = 0u;
    if (_58._m0.x > 0.0)
    {
        int _69 = int(_58._m1[_73._m0]);
        int _80 = gl_VertexIndex & 16777215;
        int _86 = _80 + _69;
        uint _90 = uint(_86 / 2);
        uint _95 = uint(16 * (_86 & 1));
        uint _101 = _105._m0[_90] >> _95;
        _51.x = _101 & 7u;
        _51.y = (_101 >> uint(3)) & 7u;
        _46.x = float((_101 >> uint(6)) & 63u) / 63.0;
        _46.y = 0.0;
        _46.z = float((_101 >> uint(12)) & 15u) / 15.0;
    }
    _144 = vec4(_46, 0.0);
    _152 = uvec3(_51.x, _51.y, 0u);
    _44 = vec4(_159.xyz, 1.0);
    vec4 _166 = (_167 * 2.0) - vec4(1.0);
    vec4 _173 = (_174 * 2.0) - vec4(1.0);
    _173.w = (floor((_174.w * 255.100006103515625) / 128.0) * 2.0) - 1.0;
    bool _193 = _58._m2.x != 0.0;
    bool _203;
    if (_193)
    {
        _203 = _198._m0.z > 0.001000000047497451305389404296875;
    }
    else
    {
        _203 = _193;
    }
    bool _209;
    if (_203)
    {
        _209 = _58._m3.x > 0.0;
    }
    else
    {
        _209 = _203;
    }
    if (_209)
    {
        vec3 _212 = vec3(_198._m0.xy, 0.0);
        float _221 = _58._m2.x;
        float _224 = _58._m2.y;
        float _227 = _58._m2.w;
        vec4 _230 = _231;
        float _233 = _58._m3.x;
        float _236 = _58._m3.y;
        float _239 = _58._m3.z;
        float _242 = _58._m3.w;
        vec4 _249 = _44;
        vec4 _251 = _248._m0;
        vec4 _245;
        _245.x = _22(_249, _251);
        vec4 _256 = _44;
        vec4 _258 = _248._m1;
        _245.y = _22(_256, _258);
        vec4 _263 = _44;
        vec4 _265 = _248._m2;
        _245.z = _22(_263, _265);
        _245.w = 1.0;
        float _271 = dot(_245.xyz, _212) * _233;
        float _278 = _230.z * _242;
        float _283 = _248._m0.w * _248._m1.w;
        float _289 = ((_198._m1.x * _58._m2.z) * _233) - _271;
        float _299 = (_230.x * 1.0) - _278;
        float _305 = sin(_289 - _299);
        float _310 = sin((_289 * 1.33000004291534423828125) - _299);
        float _317 = ((_305 + _310) * 0.25) + 0.5;
        _317 *= _317;
        float _328 = (_317 * (_224 - _221)) + _221;
        vec3 _336 = _212 * vec3(_328);
        float _341 = ((_230.y * 16.0) - _283) - _278;
        float _350 = sin(((_198._m1.x * 4.0) * _236) + _341);
        float _360 = cos(((_198._m1.x * 3.3299999237060546875) * _236) + _341);
        float _370 = (_350 + _360) * (-_230.w);
        vec3 _378 = vec3(_350 * _227, _360 * _227, _370 * _239) * vec3(_328);
        vec3 _392 = ((_336 + _378) * _198._m0.z) * _230.z;
        vec3 _405 = _245.xyz + _392;
        _245 = vec4(_405.x, _405.y, _405.z, _245.w);
        _245.w = 1.0;
        _44.x = dot(_245, _248._m3);
        _44.y = dot(_245, _248._m4);
        _44.z = dot(_245, _248._m5);
    }
    float _426 = 0.0;
    if (_58._m4.z != 0.0)
    {
        vec4 _432 = _44;
        vec4 _434 = vec4(0.0);
        vec4 _435 = vec4(0.0);
        vec4 _436 = vec4(0.0);
        uvec4 _439 = uvec4(uint(_248._m6.x + _58._m4.x)) + uvec4(_231 * 255.0);
        if (_58._m4.z == 1.0)
        {
            uint _457 = _439.x;
            _434 = _463._m0[(_457 * 3u) + 0u];
            _435 = _463._m0[(_457 * 3u) + 1u];
            _436 = _463._m0[(_457 * 3u) + 2u];
        }
        else
        {
            float _480 = _174.w * 255.100006103515625;
            vec4 _484;
            _484.y = _480 - (floor(_480 / 128.0) * 128.0);
            float _492 = _167.w * 255.100006103515625;
            _484.z = floor(_492 / 16.0);
            _484.w = _492 - (_484.z * 16.0);
            _484.y *= 0.00393700785934925079345703125;
            _484.z *= 0.02222222276031970977783203125;
            _484.w *= 0.01666666753590106964111328125;
            _484.x = 1.0 - ((_484.y + _484.z) + _484.w);
            for (uint _531 = 0u; _531 < 4u; _531++)
            {
                _434 += (_463._m0[(_439[_531] * 3u) + 0u] * _484[_531]);
            }
            for (uint _555 = 0u; _555 < 4u; _555++)
            {
                _435 += (_463._m0[(_439[_555] * 3u) + 1u] * _484[_555]);
            }
            for (uint _578 = 0u; _578 < 4u; _578++)
            {
                _436 += (_463._m0[(_439[_578] * 3u) + 2u] * _484[_578]);
            }
        }
        vec4 _601 = _432;
        vec4 _603 = _434;
        _44.x = _22(_601, _603);
        vec4 _607 = _432;
        vec4 _609 = _435;
        _44.y = _22(_607, _609);
        vec4 _613 = _432;
        vec4 _615 = _436;
        _44.z = _22(_613, _615);
        _44.w = 1.0;
        vec4 _620 = _166;
        vec4 _622 = _620;
        vec4 _624 = _434;
        _166.x = _18(_622, _624);
        vec4 _628 = _620;
        vec4 _630 = _435;
        _166.y = _18(_628, _630);
        vec4 _634 = _620;
        vec4 _636 = _436;
        _166.z = _18(_634, _636);
        vec4 _640 = _173;
        vec4 _642 = _640;
        vec4 _644 = _434;
        _173.x = _18(_642, _644);
        vec4 _648 = _640;
        vec4 _650 = _435;
        _173.y = _18(_648, _650);
        vec4 _654 = _640;
        vec4 _656 = _436;
        _173.z = _18(_654, _656);
    }
    vec3 _668 = cross(_166.xyz, _173.xyz) * _173.w;
    vec4 _660;
    _660 = vec4(_668.x, _668.y, _668.z, _660.w);
    _660.w = 0.0;
    vec4 _672 = _677._m0[_73._m1]._m0;
    vec4 _682 = _677._m0[_73._m1]._m1;
    vec4 _687 = _677._m0[_73._m1]._m2;
    vec4 _692 = _677._m0[_73._m1]._m3;
    vec4 _701 = _44;
    vec4 _703 = _672;
    gl_Position.x = _22(_701, _703);
    vec4 _708 = _44;
    vec4 _710 = _682;
    gl_Position.y = _22(_708, _710);
    vec4 _714 = _44;
    vec4 _716 = _687;
    gl_Position.z = _22(_714, _716);
    vec4 _720 = _44;
    vec4 _722 = _692;
    gl_Position.w = _22(_720, _722);
    vec4 _727 = _173;
    vec4 _729 = _248._m0;
    _726.x = _18(_727, _729);
    vec4 _734 = _660;
    vec4 _736 = _248._m0;
    _726.y = _18(_734, _736);
    vec4 _741 = _166;
    vec4 _743 = _248._m0;
    _726.z = _18(_741, _743);
    _726.w = _426;
    vec4 _751 = _173;
    vec4 _753 = _248._m1;
    _750.x = _18(_751, _753);
    vec4 _758 = _660;
    vec4 _760 = _248._m1;
    _750.y = _18(_758, _760);
    vec4 _765 = _166;
    vec4 _767 = _248._m1;
    _750.z = _18(_765, _767);
    _750.w = 0.0;
    vec4 _774 = _173;
    vec4 _776 = _248._m2;
    _773.x = _18(_774, _776);
    vec4 _781 = _660;
    vec4 _783 = _248._m2;
    _773.y = _18(_781, _783);
    vec4 _788 = _166;
    vec4 _790 = _248._m2;
    _773.z = _18(_788, _790);
    _773.w = 0.0;
    vec4 _797 = _44;
    vec4 _799 = _248._m0;
    vec4 _796;
    _796.x = _22(_797, _799);
    vec4 _804 = _44;
    vec4 _806 = _248._m1;
    _796.y = _22(_804, _806);
    vec4 _811 = _44;
    vec4 _813 = _248._m2;
    _796.z = _22(_811, _813);
    _796.w = 1.0;
    _819 = _796 - _198._m2;
    vec4 _824 = vec4(_826, _828);
    _835 = _824 + _58._m5;
    vec3 _840 = _819.xyz + _198._m2.xyz;
    _847 = vec4(0.0);
    _848 = vec4(0.0);
    _849 = vec4(0.0);
    float _850 = float(_198._m3.x > 0.0);
    float _855 = _198._m3.x * _248._m7.x;
    bool _865 = _198._m3.y > 0.0;
    bool _872;
    if (!_865)
    {
        _872 = _198._m3.z > 0.0;
    }
    else
    {
        _872 = _865;
    }
    bool _879;
    if (!_872)
    {
        _879 = _198._m3.w > 0.0;
    }
    else
    {
        _879 = _872;
    }
    float _862 = float(_879);
    vec3 _881 = vec3(0.579999983310699462890625) * _198._m3.yzw;
    _847 = vec4(_198._m3.y, _198._m3.z, _198._m3.w, _881.x);
    _848 = vec4(_881.y, _881.z, _881.x, _881.y);
    _849 = vec4(_881.z, _881.x, _881.y, _881.z);
    if ((_850 > 0.0) && (_862 <= 0.0))
    {
        float _922 = -4096.0;
        float _924 = 4096.0;
        float _926 = 256.0;
        float _928 = 256.0;
        float _929 = 6.0;
        float _931 = 256.0;
        float _932 = 256.0;
        float _933 = 24.0;
        vec3 _935 = vec3(1.0 / _931, 1.0 / _932, 1.0 / _933);
        vec3 _943 = vec3(2.0 / _931, 2.0 / _932, 2.0 / _933);
        vec3 _951 = vec3(1.0 / _926, 1.0 / _928, 1.0 / _929);
        float _959 = 1.0 / (_924 - _922);
        vec3 _971 = (_840 - vec3(_922)) * _959;
        vec3 _964 = _11(_971);
        vec4 _973 = vec4(0.0);
        uvec3 _975 = uvec3(0u);
        for (uint _977 = 0u; _977 < 13u; _977++)
        {
            vec3 _986 = vec3(0.5) + floor(vec3(2.0) * _964);
            vec4 _993 = vec4(_951 * (vec3(_975) + _986), 0.0);
            _973 = textureLod(_1007, _993.xyz, _993.w);
            _964 = fract(_964 * vec3(2.0));
            _975 = uvec3(_973.zyx * vec3(255.0));
            if (_973.w > 0.0)
            {
                break;
            }
        }
        uint _1030 = (((uint(_973.w * 255.0) << uint(24)) | (uint(_973.z * 255.0) << uint(16))) | (uint(_973.y * 255.0) << uint(8))) | uint(_973.x * 255.0);
        uvec3 _1055 = uvec3((_1030 >> uint(19)) & 4095u, (_1030 >> uint(7)) & 4095u, _1030 & 127u);
        vec3 _1068 = vec3(2.0) * ((_964 * vec3(0.5)) + vec3(0.25));
        vec4 _1074 = vec4(_935 * (vec3(_1055) + _1068), 0.0);
        vec4 _1085 = textureLod(_1086, vec4(_1074.xy, _1074.z + (_943.z * 0.0), 0.0).xyz, vec4(_1074.xy, _1074.z + (_943.z * 0.0), 0.0).w) * _855;
        vec4 _1115 = textureLod(_1086, vec4(_1074.xy, _1074.z + (_943.z * 1.0), 0.0).xyz, vec4(_1074.xy, _1074.z + (_943.z * 1.0), 0.0).w) * _855;
        vec4 _1144 = textureLod(_1086, vec4(_1074.xy, _1074.z + (_943.z * 2.0), 0.0).xyz, vec4(_1074.xy, _1074.z + (_943.z * 2.0), 0.0).w) * _855;
        _847 = vec4(_1085.x, _1115.x, _1144.x, _1085.y);
        _848 = vec4(_1115.y, _1144.y, _1085.z, _1115.z);
        _849 = vec4(_1144.z, _1085.w, _1115.w, _1144.w);
    }
    gl_Position.y = -gl_Position.y;

// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
    if(vk3d_params[VIEW].custom_params.z != 0)
    {
        if (gl_Position.w > vk3d_params[VIEW].custom_params.z)
            gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].stereo.y); 
        else
            gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].custom_params.w) *0.75;
    }
    else
    {
        gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].stereo.y); 
    }
}


