// MORE HAIR

#version 450
 #extension GL_EXT_multiview : enable
#define VIEW gl_ViewIndex


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 20, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};

layout(set = 2, binding = 0, std140) uniform _102_104
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
} _104;

layout(set = 1, binding = 0, std140) uniform _123_125
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
} _125;

layout(set = 0, binding = 1, std430) restrict readonly buffer _150_152
{
    vec4 _m0[];
} _152;

layout(set = 0, binding = 0, std140) uniform _399_401
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
} _401;

layout(set = 0, binding = 5, std430) restrict readonly buffer _1371_1373
{
    uint _m0[];
} _1373;

layout(set = 0, binding = 6, std140) uniform _1376_1378
{
    vec4 _m0[4096];
} _1378;

layout(set = 0, binding = 7, std140) uniform _1380_1382
{
    vec4 _m0[4096];
} _1382;

layout(set = 0, binding = 8, std140) uniform _1385_1387
{
    vec4 _m0[3072];
} _1387;

layout(set = 0, binding = 11, std140) uniform _1397_1399
{
    vec4 _m0[4095];
} _1399;

layout(push_constant, std430) uniform _1367_1369
{
    int _m0;
    int _m1;
} _1369;

layout(set = 0, binding = 2) uniform sampler3D _760;
layout(set = 0, binding = 3) uniform sampler3D _842;
layout(set = 0, binding = 9) uniform samplerCubeArray _1391;
layout(set = 0, binding = 10) uniform sampler2D _1395;
layout(set = 0, binding = 12) uniform sampler2DShadow _1403;
layout(set = 2, binding = 1) uniform sampler2D _1404;
layout(set = 2, binding = 2) uniform sampler2D _1405;
layout(set = 2, binding = 3) uniform sampler2D _1406;
layout(set = 2, binding = 4) uniform sampler2D _1407;

layout(location = 0) in vec4 _68;
layout(location = 2) in vec4 _76;
layout(location = 9) in vec4 _83;
layout(location = 3) in vec4 _133;
layout(location = 3) out vec4 _479;
layout(location = 4) out vec4 _503;
layout(location = 5) out vec4 _526;
layout(location = 6) out vec4 _572;
layout(location = 2) out vec4 _577;
layout(location = 1) in vec2 _580;
layout(location = 4) in vec2 _585;
layout(location = 10) out vec4 _598;
layout(location = 11) out vec4 _599;
layout(location = 12) out vec4 _600;
layout(location = 12) in vec2 _1351;
layout(location = 7) out vec4 _1358;

float _27(vec4 _25, vec4 _26)
{
    return dot(_25, _26);
}

float _23(vec4 _21, vec4 _22)
{
    return dot(_21.xyz, _22.xyz);
}

mat4 _34(mat4 _32, mat4 _33)
{
    return _32 * _33;
}

vec3 _16(vec3 _15)
{
    return clamp(_15, vec3(0.0), vec3(1.0));
}

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

void main()
{
    vec4 _65 = vec4(0.0);
    _65 = vec4(_68.xyz, 1.0);
    vec4 _75 = (_76 * 2.0) - vec4(1.0);
    vec4 _82 = (_83 * 2.0) - vec4(1.0);
    _82.w = (floor((_83.w * 255.100006103515625) / 128.0) * 2.0) - 1.0;
    float _101 = 0.0;
    if (_104._m0.z != 0.0)
    {
        vec4 _115 = _65;
        vec4 _117 = vec4(0.0);
        vec4 _118 = vec4(0.0);
        vec4 _119 = vec4(0.0);
        uvec4 _122 = uvec4(uint(_125._m0.x + _104._m0.x)) + uvec4(_133 * 255.0);
        if (_104._m0.z == 1.0)
        {
            uint _146 = _122.x;
            _117 = _152._m0[(_146 * 3u) + 0u];
            _118 = _152._m0[(_146 * 3u) + 1u];
            _119 = _152._m0[(_146 * 3u) + 2u];
        }
        else
        {
            float _171 = _83.w * 255.100006103515625;
            vec4 _175;
            _175.y = _171 - (floor(_171 / 128.0) * 128.0);
            float _183 = _76.w * 255.100006103515625;
            _175.z = floor(_183 / 16.0);
            _175.w = _183 - (_175.z * 16.0);
            _175.y *= 0.00393700785934925079345703125;
            _175.z *= 0.02222222276031970977783203125;
            _175.w *= 0.01666666753590106964111328125;
            _175.x = 1.0 - ((_175.y + _175.z) + _175.w);
            for (uint _223 = 0u; _223 < 4u; _223++)
            {
                _117 += (_152._m0[(_122[_223] * 3u) + 0u] * _175[_223]);
            }
            for (uint _248 = 0u; _248 < 4u; _248++)
            {
                _118 += (_152._m0[(_122[_248] * 3u) + 1u] * _175[_248]);
            }
            for (uint _271 = 0u; _271 < 4u; _271++)
            {
                _119 += (_152._m0[(_122[_271] * 3u) + 2u] * _175[_271]);
            }
        }
        vec4 _294 = _115;
        vec4 _296 = _117;
        _65.x = _27(_294, _296);
        vec4 _300 = _115;
        vec4 _302 = _118;
        _65.y = _27(_300, _302);
        vec4 _306 = _115;
        vec4 _308 = _119;
        _65.z = _27(_306, _308);
        _65.w = 1.0;
        vec4 _313 = _75;
        vec4 _315 = _313;
        vec4 _317 = _117;
        _75.x = _23(_315, _317);
        vec4 _321 = _313;
        vec4 _323 = _118;
        _75.y = _23(_321, _323);
        vec4 _327 = _313;
        vec4 _329 = _119;
        _75.z = _23(_327, _329);
        vec4 _333 = _82;
        vec4 _335 = _333;
        vec4 _337 = _117;
        _82.x = _23(_335, _337);
        vec4 _341 = _333;
        vec4 _343 = _118;
        _82.y = _23(_341, _343);
        vec4 _347 = _333;
        vec4 _349 = _119;
        _82.z = _23(_347, _349);
    }
    vec3 _361 = cross(_75.xyz, _82.xyz) * _82.w;
    vec4 _353;
    _353 = vec4(_361.x, _361.y, _361.z, _353.w);
    _353.w = 0.0;
    mat4 _365 = mat4(vec4(_125._m1), vec4(_125._m2), vec4(_125._m3), vec4(_125._m4));
    mat4 _398 = mat4(vec4(_401._m0), vec4(_401._m1), vec4(_401._m2), vec4(_401._m3));
    mat4 _432 = _365;
    mat4 _434 = _398;
    mat4 _431 = _34(_432, _434);
    vec4 _437 = _431[0];
    vec4 _440 = _431[1];
    vec4 _443 = _431[2];
    vec4 _446 = _431[3];
    vec4 _453 = _65;
    vec4 _455 = _437;
    gl_Position.x = _27(_453, _455);
    vec4 _460 = _65;
    vec4 _462 = _440;
    gl_Position.y = _27(_460, _462);
    vec4 _466 = _65;
    vec4 _468 = _443;
    gl_Position.z = _27(_466, _468);
    vec4 _472 = _65;
    vec4 _474 = _446;
    gl_Position.w = _27(_472, _474);
    vec4 _480 = _82;
    vec4 _482 = _125._m1;
    _479.x = _23(_480, _482);
    vec4 _487 = _353;
    vec4 _489 = _125._m1;
    _479.y = _23(_487, _489);
    vec4 _494 = _75;
    vec4 _496 = _125._m1;
    _479.z = _23(_494, _496);
    _479.w = _101;
    vec4 _504 = _82;
    vec4 _506 = _125._m2;
    _503.x = _23(_504, _506);
    vec4 _511 = _353;
    vec4 _513 = _125._m2;
    _503.y = _23(_511, _513);
    vec4 _518 = _75;
    vec4 _520 = _125._m2;
    _503.z = _23(_518, _520);
    _503.w = 0.0;
    vec4 _527 = _82;
    vec4 _529 = _125._m3;
    _526.x = _23(_527, _529);
    vec4 _534 = _353;
    vec4 _536 = _125._m3;
    _526.y = _23(_534, _536);
    vec4 _541 = _75;
    vec4 _543 = _125._m3;
    _526.z = _23(_541, _543);
    _526.w = 0.0;
    vec4 _550 = _65;
    vec4 _552 = _125._m1;
    vec4 _549;
    _549.x = _27(_550, _552);
    vec4 _557 = _65;
    vec4 _559 = _125._m2;
    _549.y = _27(_557, _559);
    vec4 _564 = _65;
    vec4 _566 = _125._m3;
    _549.z = _27(_564, _566);
    _549.w = 1.0;
    _572 = _549 - _401._m4;
    _577 = vec4(_580.x, _580.y, _585.x, _585.y);
    vec3 _591 = _572.xyz + _401._m4.xyz;
    _598 = vec4(0.0);
    _599 = vec4(0.0);
    _600 = vec4(0.0);
    float _601 = float(_401._m5.x > 0.0);
    float _607 = _401._m5.x * _125._m5.x;
    bool _616 = _401._m5.y > 0.0;
    bool _623;
    if (!_616)
    {
        _623 = _401._m5.z > 0.0;
    }
    else
    {
        _623 = _616;
    }
    bool _630;
    if (!_623)
    {
        _630 = _401._m5.w > 0.0;
    }
    else
    {
        _630 = _623;
    }
    float _613 = float(_630);
    vec3 _632 = vec3(0.579999983310699462890625) * _401._m5.yzw;
    _598 = vec4(_401._m5.y, _401._m5.z, _401._m5.w, _632.x);
    _599 = vec4(_632.y, _632.z, _632.x, _632.y);
    _600 = vec4(_632.z, _632.x, _632.y, _632.z);
    if ((_601 > 0.0) && (_613 <= 0.0))
    {
        float _673 = -4096.0;
        float _675 = 4096.0;
        float _677 = 256.0;
        float _679 = 256.0;
        float _680 = 6.0;
        float _682 = 256.0;
        float _683 = 256.0;
        float _684 = 24.0;
        vec3 _686 = vec3(1.0 / _682, 1.0 / _683, 1.0 / _684);
        vec3 _694 = vec3(2.0 / _682, 2.0 / _683, 2.0 / _684);
        vec3 _702 = vec3(1.0 / _677, 1.0 / _679, 1.0 / _680);
        float _710 = 1.0 / (_675 - _673);
        vec3 _722 = (_591 - vec3(_673)) * _710;
        vec3 _715 = _16(_722);
        vec4 _724 = vec4(0.0);
        uvec3 _727 = uvec3(0u);
        for (uint _729 = 0u; _729 < 13u; _729++)
        {
            vec3 _738 = vec3(0.5) + floor(vec3(2.0) * _715);
            vec4 _746 = vec4(_702 * (vec3(_727) + _738), 0.0);
            _724 = textureLod(_760, _746.xyz, _746.w);
            _715 = fract(_715 * vec3(2.0));
            _727 = uvec3(_724.zyx * vec3(255.0));
            if (_724.w > 0.0)
            {
                break;
            }
        }
        uint _783 = (((uint(_724.w * 255.0) << uint(24)) | (uint(_724.z * 255.0) << uint(16))) | (uint(_724.y * 255.0) << uint(8))) | uint(_724.x * 255.0);
        uvec3 _809 = uvec3((_783 >> uint(19)) & 4095u, (_783 >> uint(7)) & 4095u, _783 & 127u);
        vec3 _823 = vec3(2.0) * ((_715 * vec3(0.5)) + vec3(0.25));
        vec4 _830 = vec4(_686 * (vec3(_809) + _823), 0.0);
        vec4 _841 = textureLod(_842, vec4(_830.xy, _830.z + (_694.z * 0.0), 0.0).xyz, vec4(_830.xy, _830.z + (_694.z * 0.0), 0.0).w) * _607;
        vec4 _871 = textureLod(_842, vec4(_830.xy, _830.z + (_694.z * 1.0), 0.0).xyz, vec4(_830.xy, _830.z + (_694.z * 1.0), 0.0).w) * _607;
        vec4 _900 = textureLod(_842, vec4(_830.xy, _830.z + (_694.z * 2.0), 0.0).xyz, vec4(_830.xy, _830.z + (_694.z * 2.0), 0.0).w) * _607;
        _598 = vec4(_841.x, _871.x, _900.x, _841.y);
        _599 = vec4(_871.y, _900.y, _841.z, _871.z);
        _600 = vec4(_900.z, _841.w, _871.w, _900.w);
    }
    gl_Position.z -= 0.0001904999953694641590118408203125;
    vec4 _961 = vec4(_68.xyz, 1.0);
    vec4 _968 = (_76 * 2.0) - vec4(1.0);
    vec4 _973 = (_83 * 2.0) - vec4(1.0);
    _973.w = (floor((_83.w * 255.100006103515625) / 128.0) * 2.0) - 1.0;
    float _986 = 0.0;
    if (_104._m0.z != 0.0)
    {
        vec4 _992 = _961;
        vec4 _994 = vec4(0.0);
        vec4 _995 = vec4(0.0);
        vec4 _996 = vec4(0.0);
        uvec4 _997 = uvec4(uint(_125._m0.x + _104._m0.x)) + uvec4(_133 * 255.0);
        if (_104._m0.z == 1.0)
        {
            uint _1014 = _997.x;
            _994 = _152._m0[(_1014 * 3u) + 0u];
            _995 = _152._m0[(_1014 * 3u) + 1u];
            _996 = _152._m0[(_1014 * 3u) + 2u];
        }
        else
        {
            float _1033 = _83.w * 255.100006103515625;
            vec4 _1037;
            _1037.y = _1033 - (floor(_1033 / 128.0) * 128.0);
            float _1045 = _76.w * 255.100006103515625;
            _1037.z = floor(_1045 / 16.0);
            _1037.w = _1045 - (_1037.z * 16.0);
            _1037.y *= 0.00393700785934925079345703125;
            _1037.z *= 0.02222222276031970977783203125;
            _1037.w *= 0.01666666753590106964111328125;
            _1037.x = 1.0 - ((_1037.y + _1037.z) + _1037.w);
            for (uint _1081 = 0u; _1081 < 4u; _1081++)
            {
                _994 += (_152._m0[(_997[_1081] * 3u) + 0u] * _1037[_1081]);
            }
            for (uint _1104 = 0u; _1104 < 4u; _1104++)
            {
                _995 += (_152._m0[(_997[_1104] * 3u) + 1u] * _1037[_1104]);
            }
            for (uint _1127 = 0u; _1127 < 4u; _1127++)
            {
                _996 += (_152._m0[(_997[_1127] * 3u) + 2u] * _1037[_1127]);
            }
        }
        vec4 _1150 = _992;
        vec4 _1152 = _994;
        _961.x = _27(_1150, _1152);
        vec4 _1156 = _992;
        vec4 _1158 = _995;
        _961.y = _27(_1156, _1158);
        vec4 _1162 = _992;
        vec4 _1164 = _996;
        _961.z = _27(_1162, _1164);
        _961.w = 1.0;
        vec4 _1169 = _968;
        vec4 _1171 = _1169;
        vec4 _1173 = _994;
        _968.x = _23(_1171, _1173);
        vec4 _1177 = _1169;
        vec4 _1179 = _995;
        _968.y = _23(_1177, _1179);
        vec4 _1183 = _1169;
        vec4 _1185 = _996;
        _968.z = _23(_1183, _1185);
        vec4 _1189 = _973;
        vec4 _1191 = _1189;
        vec4 _1193 = _994;
        _973.x = _23(_1191, _1193);
        vec4 _1197 = _1189;
        vec4 _1199 = _995;
        _973.y = _23(_1197, _1199);
        vec4 _1203 = _1189;
        vec4 _1205 = _996;
        _973.z = _23(_1203, _1205);
    }
    float _1209 = length(_125._m6.xyz - _961.xyz);
    float _1227 = abs(_1209 - _125._m7.z) / _125._m7.x;
    float _1218 = 1.0 - _10(_1227);
    float _1230 = ((_1218 * _1218) * _125._m7.y) * 0.00999999977648258209228515625;
    _961 += (_968 * vec4(_1230, _1230, _1230, 0.0));
    mat4 _1247 = mat4(vec4(_125._m1), vec4(_125._m2), vec4(_125._m3), vec4(_125._m4));
    mat4 _1277 = mat4(vec4(_401._m0), vec4(_401._m1), vec4(_401._m2), vec4(_401._m3));
    mat4 _1308 = _1247;
    mat4 _1310 = _1277;
    mat4 _1307 = _34(_1308, _1310);
    vec4 _1313 = _1307[0];
    vec4 _1316 = _1307[1];
    vec4 _1319 = _1307[2];
    vec4 _1322 = _1307[3];
    vec4 _1325 = _961;
    vec4 _1327 = _1313;
    gl_Position.x = _27(_1325, _1327);
    vec4 _1331 = _961;
    vec4 _1333 = _1316;
    gl_Position.y = _27(_1331, _1333);
    vec4 _1337 = _961;
    vec4 _1339 = _1319;
    gl_Position.z = _27(_1337, _1339);
    vec4 _1343 = _961;
    vec4 _1345 = _1322;
    gl_Position.w = _27(_1343, _1345);
    vec4 _1349 = vec4(_580, _1351);
    _1358 = _1349 + _104._m1;
    gl_Position.y = -gl_Position.y;

    // Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
    if(vk3d_params[VIEW].custom_params.z != 0)
    {
        if (gl_Position.w > vk3d_params[VIEW].custom_params.z)
            gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].stereo.y); 
        else
            gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].custom_params.w) *0.75;
    }
    else
    {
        gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].stereo.y); 
    }
 
}


