// BODY 2
#version 450
 #extension GL_EXT_multiview : enable
#define VIEW gl_ViewIndex

struct _32
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
};


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
 
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 10, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};


   

layout(set = 0, binding = 1, std430) restrict readonly buffer _34_36
{
    _32 _m0[];
} _36;

layout(set = 2, binding = 0, std140) uniform _78_80
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
} _80;

layout(set = 0, binding = 0, std140) uniform _91_93
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
} _93;

layout(set = 1, binding = 0, std140) uniform _146_148
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
    vec4 _m21;
} _148;

layout(set = 0, binding = 2, std430) restrict readonly buffer _367_369
{
    vec4 _m0[];
} _369;

layout(push_constant, std430) uniform _39_41
{
    int _m0;
    int _m1;
} _41;

layout(location = 0) in vec4 _68;
layout(location = 3) in vec4 _131;
layout(location = 9) in vec4 _387;
layout(location = 2) in vec4 _403;
layout(location = 10) out vec4 _1070;
layout(location = 11) out vec4 _1584;

float _12(vec4 _10, vec4 _11)
{
    return dot(_10, _11);
}

mat4 _19(mat4 _17, mat4 _18)
{
    return _17 * _18;
}

void main()
{
    vec4 _31 = _36._m0[_41._m1]._m0;
    vec4 _49 = _36._m0[_41._m1]._m1;
    vec4 _54 = _36._m0[_41._m1]._m2;
    vec4 _60 = _36._m0[_41._m1]._m3;
    vec4 _66 = vec4(_68.xyz, 1.0);
    bool _88 = _80._m4.x != 0.0;
    bool _99;
    if (_88)
    {
        _99 = _93._m0.z > 0.001000000047497451305389404296875;
    }
    else
    {
        _99 = _88;
    }
    bool _106;
    if (_99)
    {
        _106 = _80._m5.x > 0.0;
    }
    else
    {
        _106 = _99;
    }
    if (_106)
    {
        vec3 _110 = vec3(_93._m0.xy, 0.0);
        float _119 = _80._m4.x;
        float _122 = _80._m4.y;
        float _126 = _80._m4.w;
        vec4 _130 = _131;
        float _133 = _80._m5.x;
        float _136 = _80._m5.y;
        float _139 = _80._m5.z;
        float _142 = _80._m5.w;
        vec4 _149 = _66;
        vec4 _151 = _148._m5;
        vec4 _145;
        _145.x = _12(_149, _151);
        vec4 _157 = _66;
        vec4 _159 = _148._m6;
        _145.y = _12(_157, _159);
        vec4 _165 = _66;
        vec4 _167 = _148._m7;
        _145.z = _12(_165, _167);
        _145.w = 1.0;
        float _173 = dot(_145.xyz, _110) * _133;
        float _180 = _130.z * _142;
        float _185 = _148._m5.w * _148._m6.w;
        float _191 = ((_93._m1.x * _80._m4.z) * _133) - _173;
        float _201 = (_130.x * 1.0) - _180;
        float _207 = sin(_191 - _201);
        float _212 = sin((_191 * 1.33000004291534423828125) - _201);
        float _219 = ((_207 + _212) * 0.25) + 0.5;
        _219 *= _219;
        float _230 = (_219 * (_122 - _119)) + _119;
        vec3 _238 = _110 * vec3(_230);
        float _243 = ((_130.y * 16.0) - _185) - _180;
        float _252 = sin(((_93._m1.x * 4.0) * _136) + _243);
        float _262 = cos(((_93._m1.x * 3.3299999237060546875) * _136) + _243);
        float _272 = (_252 + _262) * (-_130.w);
        vec3 _280 = vec3(_252 * _126, _262 * _126, _272 * _139) * vec3(_230);
        vec3 _294 = ((_238 + _280) * _93._m0.z) * _130.z;
        vec3 _307 = _145.xyz + _294;
        _145 = vec4(_307.x, _307.y, _307.z, _145.w);
        _145.w = 1.0;
        _66.x = dot(_145, _148._m13);
        _66.y = dot(_145, _148._m14);
        _66.z = dot(_145, _148._m15);
    }
    if (_80._m8.z != 0.0)
    {
        vec4 _335 = _66;
        vec4 _337 = vec4(0.0);
        vec4 _339 = vec4(0.0);
        vec4 _340 = vec4(0.0);
        uvec4 _343 = uvec4(uint(_148._m21.x + _80._m8.x)) + uvec4(_131 * 255.0);
        if (_80._m8.z == 1.0)
        {
            uint _363 = _343.x;
            _337 = _369._m0[(_363 * 3u) + 0u];
            _339 = _369._m0[(_363 * 3u) + 1u];
            _340 = _369._m0[(_363 * 3u) + 2u];
        }
        else
        {
            float _386 = _387.w * 255.100006103515625;
            vec4 _393;
            _393.y = _386 - (floor(_386 / 128.0) * 128.0);
            float _402 = _403.w * 255.100006103515625;
            _393.z = floor(_402 / 16.0);
            _393.w = _402 - (_393.z * 16.0);
            _393.y *= 0.00393700785934925079345703125;
            _393.z *= 0.02222222276031970977783203125;
            _393.w *= 0.01666666753590106964111328125;
            _393.x = 1.0 - ((_393.y + _393.z) + _393.w);
            for (uint _442 = 0u; _442 < 4u; _442++)
            {
                _337 += (_369._m0[(_343[_442] * 3u) + 0u] * _393[_442]);
            }
            for (uint _466 = 0u; _466 < 4u; _466++)
            {
                _339 += (_369._m0[(_343[_466] * 3u) + 1u] * _393[_466]);
            }
            for (uint _489 = 0u; _489 < 4u; _489++)
            {
                _340 += (_369._m0[(_343[_489] * 3u) + 2u] * _393[_489]);
            }
        }
        vec4 _512 = _335;
        vec4 _514 = _337;
        _66.x = _12(_512, _514);
        vec4 _518 = _335;
        vec4 _520 = _339;
        _66.y = _12(_518, _520);
        vec4 _524 = _335;
        vec4 _526 = _340;
        _66.z = _12(_524, _526);
        _66.w = 1.0;
    }
    vec4 _535 = _66;
    vec4 _537 = _31;
    gl_Position.x = _12(_535, _537);
    vec4 _542 = _66;
    vec4 _544 = _49;
    gl_Position.y = _12(_542, _544);
    vec4 _548 = _66;
    vec4 _550 = _54;
    gl_Position.z = _12(_548, _550);
    vec4 _554 = _66;
    vec4 _556 = _60;
    gl_Position.w = _12(_554, _556);
    mat4 _560 = mat4(vec4(_148._m5), vec4(_148._m6), vec4(_148._m7), vec4(_148._m4));
    mat4 _590 = mat4(vec4(_93._m2), vec4(_93._m3), vec4(_93._m4), vec4(_93._m5));
    mat4 _621 = _560;
    mat4 _623 = _590;
    mat4 _620 = _19(_621, _623);
    vec4 _626 = _620[0];
    vec4 _629 = _620[1];
    vec4 _632 = _620[2];
    vec4 _635 = _620[3];
    vec4 _638 = vec4(_68.xyz, 1.0);
    bool _647 = _80._m4.x != 0.0;
    bool _653;
    if (_647)
    {
        _653 = _93._m0.z > 0.001000000047497451305389404296875;
    }
    else
    {
        _653 = _647;
    }
    bool _659;
    if (_653)
    {
        _659 = _80._m5.x > 0.0;
    }
    else
    {
        _659 = _653;
    }
    if (_659)
    {
        vec3 _662 = vec3(_93._m0.xy, 0.0);
        float _669 = _80._m4.x;
        float _672 = _80._m4.y;
        float _675 = _80._m4.w;
        vec4 _678 = _131;
        float _680 = _80._m5.x;
        float _683 = _80._m5.y;
        float _686 = _80._m5.z;
        float _689 = _80._m5.w;
        vec4 _693 = _638;
        vec4 _695 = _148._m5;
        vec4 _692;
        _692.x = _12(_693, _695);
        vec4 _700 = _638;
        vec4 _702 = _148._m6;
        _692.y = _12(_700, _702);
        vec4 _707 = _638;
        vec4 _709 = _148._m7;
        _692.z = _12(_707, _709);
        _692.w = 1.0;
        float _715 = dot(_692.xyz, _662) * _680;
        float _722 = _678.z * _689;
        float _727 = _148._m5.w * _148._m6.w;
        float _733 = ((_93._m1.x * _80._m4.z) * _680) - _715;
        float _743 = (_678.x * 1.0) - _722;
        float _749 = sin(_733 - _743);
        float _754 = sin((_733 * 1.33000004291534423828125) - _743);
        float _760 = ((_749 + _754) * 0.25) + 0.5;
        _760 *= _760;
        float _769 = (_760 * (_672 - _669)) + _669;
        vec3 _777 = _662 * vec3(_769);
        float _782 = ((_678.y * 16.0) - _727) - _722;
        float _790 = sin(((_93._m1.x * 4.0) * _683) + _782);
        float _799 = cos(((_93._m1.x * 3.3299999237060546875) * _683) + _782);
        float _808 = (_790 + _799) * (-_678.w);
        vec3 _816 = vec3(_790 * _675, _799 * _675, _808 * _686) * vec3(_769);
        vec3 _830 = ((_777 + _816) * _93._m0.z) * _678.z;
        vec3 _843 = _692.xyz + _830;
        _692 = vec4(_843.x, _843.y, _843.z, _692.w);
        _692.w = 1.0;
        _638.x = dot(_692, _148._m13);
        _638.y = dot(_692, _148._m14);
        _638.z = dot(_692, _148._m15);
    }
    if (_80._m8.z != 0.0)
    {
        vec4 _867 = _638;
        vec4 _869 = vec4(0.0);
        vec4 _870 = vec4(0.0);
        vec4 _871 = vec4(0.0);
        uvec4 _872 = uvec4(uint(_148._m21.x + _80._m8.x)) + uvec4(_131 * 255.0);
        if (_80._m8.z == 1.0)
        {
            uint _889 = _872.x;
            _869 = _369._m0[(_889 * 3u) + 0u];
            _870 = _369._m0[(_889 * 3u) + 1u];
            _871 = _369._m0[(_889 * 3u) + 2u];
        }
        else
        {
            float _908 = _387.w * 255.100006103515625;
            vec4 _912;
            _912.y = _908 - (floor(_908 / 128.0) * 128.0);
            float _920 = _403.w * 255.100006103515625;
            _912.z = floor(_920 / 16.0);
            _912.w = _920 - (_912.z * 16.0);
            _912.y *= 0.00393700785934925079345703125;
            _912.z *= 0.02222222276031970977783203125;
            _912.w *= 0.01666666753590106964111328125;
            _912.x = 1.0 - ((_912.y + _912.z) + _912.w);
            for (uint _956 = 0u; _956 < 4u; _956++)
            {
                _869 += (_369._m0[(_872[_956] * 3u) + 0u] * _912[_956]);
            }
            for (uint _979 = 0u; _979 < 4u; _979++)
            {
                _870 += (_369._m0[(_872[_979] * 3u) + 1u] * _912[_979]);
            }
            for (uint _1002 = 0u; _1002 < 4u; _1002++)
            {
                _871 += (_369._m0[(_872[_1002] * 3u) + 2u] * _912[_1002]);
            }
        }
        vec4 _1025 = _867;
        vec4 _1027 = _869;
        _638.x = _12(_1025, _1027);
        vec4 _1031 = _867;
        vec4 _1033 = _870;
        _638.y = _12(_1031, _1033);
        vec4 _1037 = _867;
        vec4 _1039 = _871;
        _638.z = _12(_1037, _1039);
        _638.w = 1.0;
    }
    vec4 _1045 = _638;
    vec4 _1047 = _626;
    vec4 _1044;
    _1044.x = _12(_1045, _1047);
    vec4 _1051 = _638;
    vec4 _1053 = _629;
    _1044.y = _12(_1051, _1053);
    vec4 _1057 = _638;
    vec4 _1059 = _632;
    _1044.z = _12(_1057, _1059);
    vec4 _1063 = _638;
    vec4 _1065 = _635;
    _1044.w = _12(_1063, _1065);
    _1070 = _1044;
    mat4 _1072 = mat4(vec4(_148._m8), vec4(_148._m9), vec4(_148._m10), vec4(_148._m11));
    mat4 _1105 = mat4(vec4(_93._m6), vec4(_93._m7), vec4(_93._m8), vec4(_93._m9));
    mat4 _1136 = _1072;
    mat4 _1138 = _1105;
    mat4 _1135 = _19(_1136, _1138);
    vec4 _1141 = _1135[0];
    vec4 _1144 = _1135[1];
    vec4 _1147 = _1135[2];
    vec4 _1150 = _1135[3];
    vec4 _1153 = vec4(_68.xyz, 1.0);
    bool _1162 = _80._m4.x != 0.0;
    bool _1168;
    if (_1162)
    {
        _1168 = _93._m0.z > 0.001000000047497451305389404296875;
    }
    else
    {
        _1168 = _1162;
    }
    bool _1174;
    if (_1168)
    {
        _1174 = _80._m5.x > 0.0;
    }
    else
    {
        _1174 = _1168;
    }
    if (_1174)
    {
        vec3 _1177 = vec3(_93._m0.xy, 0.0);
        float _1184 = _80._m4.x;
        float _1187 = _80._m4.y;
        float _1190 = _80._m4.w;
        vec4 _1193 = _131;
        float _1195 = _80._m5.x;
        float _1198 = _80._m5.y;
        float _1201 = _80._m5.z;
        float _1204 = _80._m5.w;
        vec4 _1208 = _1153;
        vec4 _1210 = _148._m5;
        vec4 _1207;
        _1207.x = _12(_1208, _1210);
        vec4 _1215 = _1153;
        vec4 _1217 = _148._m6;
        _1207.y = _12(_1215, _1217);
        vec4 _1222 = _1153;
        vec4 _1224 = _148._m7;
        _1207.z = _12(_1222, _1224);
        _1207.w = 1.0;
        float _1230 = dot(_1207.xyz, _1177) * _1195;
        float _1237 = _1193.z * _1204;
        float _1242 = _148._m5.w * _148._m6.w;
        float _1248 = ((_93._m1.x * _80._m4.z) * _1195) - _1230;
        float _1258 = (_1193.x * 1.0) - _1237;
        float _1264 = sin(_1248 - _1258);
        float _1269 = sin((_1248 * 1.33000004291534423828125) - _1258);
        float _1275 = ((_1264 + _1269) * 0.25) + 0.5;
        _1275 *= _1275;
        float _1284 = (_1275 * (_1187 - _1184)) + _1184;
        vec3 _1292 = _1177 * vec3(_1284);
        float _1297 = ((_1193.y * 16.0) - _1242) - _1237;
        float _1305 = sin(((_93._m1.x * 4.0) * _1198) + _1297);
        float _1314 = cos(((_93._m1.x * 3.3299999237060546875) * _1198) + _1297);
        float _1323 = (_1305 + _1314) * (-_1193.w);
        vec3 _1331 = vec3(_1305 * _1190, _1314 * _1190, _1323 * _1201) * vec3(_1284);
        vec3 _1345 = ((_1292 + _1331) * _93._m0.z) * _1193.z;
        vec3 _1358 = _1207.xyz + _1345;
        _1207 = vec4(_1358.x, _1358.y, _1358.z, _1207.w);
        _1207.w = 1.0;
        _1153.x = dot(_1207, _148._m13);
        _1153.y = dot(_1207, _148._m14);
        _1153.z = dot(_1207, _148._m15);
    }
    if (_80._m8.z != 0.0)
    {
        vec4 _1382 = _1153;
        vec4 _1384 = vec4(0.0);
        vec4 _1385 = vec4(0.0);
        vec4 _1386 = vec4(0.0);
        uvec4 _1387 = uvec4(uint(_148._m21.y + _80._m8.y)) + uvec4(_131 * 255.0);
        if (_80._m8.z == 1.0)
        {
            uint _1404 = _1387.x;
            _1384 = _369._m0[(_1404 * 3u) + 0u];
            _1385 = _369._m0[(_1404 * 3u) + 1u];
            _1386 = _369._m0[(_1404 * 3u) + 2u];
        }
        else
        {
            float _1423 = _387.w * 255.100006103515625;
            vec4 _1427;
            _1427.y = _1423 - (floor(_1423 / 128.0) * 128.0);
            float _1435 = _403.w * 255.100006103515625;
            _1427.z = floor(_1435 / 16.0);
            _1427.w = _1435 - (_1427.z * 16.0);
            _1427.y *= 0.00393700785934925079345703125;
            _1427.z *= 0.02222222276031970977783203125;
            _1427.w *= 0.01666666753590106964111328125;
            _1427.x = 1.0 - ((_1427.y + _1427.z) + _1427.w);
            for (uint _1471 = 0u; _1471 < 4u; _1471++)
            {
                _1384 += (_369._m0[(_1387[_1471] * 3u) + 0u] * _1427[_1471]);
            }
            for (uint _1494 = 0u; _1494 < 4u; _1494++)
            {
                _1385 += (_369._m0[(_1387[_1494] * 3u) + 1u] * _1427[_1494]);
            }
            for (uint _1517 = 0u; _1517 < 4u; _1517++)
            {
                _1386 += (_369._m0[(_1387[_1517] * 3u) + 2u] * _1427[_1517]);
            }
        }
        vec4 _1540 = _1382;
        vec4 _1542 = _1384;
        _1153.x = _12(_1540, _1542);
        vec4 _1546 = _1382;
        vec4 _1548 = _1385;
        _1153.y = _12(_1546, _1548);
        vec4 _1552 = _1382;
        vec4 _1554 = _1386;
        _1153.z = _12(_1552, _1554);
        _1153.w = 1.0;
    }
    vec4 _1560 = _1153;
    vec4 _1562 = _1141;
    vec4 _1559;
    _1559.x = _12(_1560, _1562);
    vec4 _1566 = _1153;
    vec4 _1568 = _1144;
    _1559.y = _12(_1566, _1568);
    vec4 _1572 = _1153;
    vec4 _1574 = _1147;
    _1559.z = _12(_1572, _1574);
    vec4 _1578 = _1153;
    vec4 _1580 = _1150;
    _1559.w = _12(_1578, _1580);
    _1584 = _1559;
    gl_Position.y = -gl_Position.y;

// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
    if(vk3d_params[VIEW].custom_params.z != 0)
    {
        if (gl_Position.w > vk3d_params[VIEW].custom_params.z)
            gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].stereo.y); 
        else
            gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].custom_params.w) *0.75;
    }
    else
    {
        gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].stereo.y); 
    }
}



